//Drain Arcane.cs

datablock AudioProfile(DrainArcaneExplosionSound)
{
   filename    = "./DrainArcaneHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(DrainArcaneFireSound)
{
   filename    = "./DrainArcaneFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DrainArcaneChargingSound)
{
   filename    = "./DrainArcaneCharging.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(DrainArcaneChargedSound)
{
   filename    = "./DrainArcaneCharged.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(DrainArcaneCastParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 30;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.45 0.8 0.9";
	colors[1]     = "0.75 0.45 0.8";
	sizes[0]      = 0.95;
	sizes[1]      = 1.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DrainArcaneCastEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DrainArcaneCastParticle";

   uiName = "Drain Arcane Cast";
};

datablock ParticleData(DrainArcaneChargedParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 100;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.5 0.8 0.4";
	colors[1]     = "0.8 0.5 0.8 0.0";
	sizes[0]      = 0.28;
	sizes[1]      = 0.23;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DrainArcaneChargedEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DrainArcaneChargedParticle";

   uiName = "Drain Arcane Charged";
};

datablock ParticleData(DrainArcaneChargingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.25 0.7 0.4";
	colors[1]     = "0.75 0.25 0.7 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DrainArcaneChargingEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = -5.0;
   velocityVariance = 2.0;
   ejectionOffset   = 0.75;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DrainArcaneChargingParticle";

   uiName = "Drain Arcane Charging";
};


datablock ParticleData(DrainArcaneProjectileParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 240.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.75 0.1 1 0.4";
	colors[1]     = "0.75 0.1 1 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleEmitterData(DrainArcaneProjectileEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DrainArcaneProjectileParticle";

   uiName = "Drain Arcane Trail";
};

datablock ParticleData(DrainArcaneExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.45 0.8 0.9";
	colors[1]     = "0.75 0.45 0.8 0.0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.4;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DrainArcaneExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DrainArcaneExplosionParticle";

   useEmitterColors = true;
   uiName = "Drain Arcane Hit";
};

datablock ExplosionData(DrainArcaneExplosion)
{
   //explosionShape = "";
	soundProfile = DrainArcaneExplosionSound;

   lifeTimeMS = 120;

   emitter[0] = DrainArcaneExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0.15;
   lightEndRadius = 0.0;
   lightStartColor = "0.8 0.65 0.2";
   lightEndColor = "0 0 0";
};

//projectile
AddDamageType("DrainArcane",   '<bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',       '%2 <bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',1,1);
datablock ProjectileData(DrainArcaneProjectile)
{
   directDamage        = 2;
   directDamageType    = $DamageType::DrainArcane;
   radiusDamageType    = $DamageType::DrainArcane;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = DrainArcaneExplosion;
   particleEmitter     = DrainArcaneProjectileEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 145;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "DrainArcane";
};


//////////
// item //
//////////
datablock ItemData(DrainArcaneItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ArcaneDrainSymbol.dts";
                  rotate = true;
	emap = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	//gui stuff
	uiName = "Arcane - Drain";
	iconName = "./DrainArcane_Icon";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = DrainArcaneImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DrainArcaneImage)
{
   // Basic Item properties
   shapeFile = "./ArcaneDrain.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.5 -0.6 -0.5";
   eyeOffset = "-0.385 1.05 -1.95";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = DrainArcaneItem;
   ammo = " ";
   projectile = DrainArcaneProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arms up or not
   armReady = true;
   LarmReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	// Plays activate animation for 1 second when you first pull it out
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.0;
	stateSequence[0]	= "Activate";
	stateTransitionOnTimeout[0]       = "Ready";
	
	// We're idle and ready to start charging
	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1] = "Charge";
	stateSequence[1]	= "Ready";
	stateAllowImageChange[1]	= true;
	
	// Play charge animation for 1.25 seconds. Return to ready if released early
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 1.0;
                  stateSequence[2]	= "Charge";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateEmitter[2]					= DrainArcaneChargingEmitter;
	stateEmitterTime[2]				= 0.78;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]				= DrainArcaneChargingSound;
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = true;

                  // We wanted to abort the charge state
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.05;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= true;
	
	// We're charged up, go to Fire state when we release mouse
	stateName[4]			= "Armed";
	stateTimeoutValue[4]		= 0.3;
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateEmitter[4]					= DrainArcaneChargedEmitter;
	stateEmitterTime[4]				= 0.1;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]				= DrainArcaneChargedSound;
	stateAllowImageChange[4]	= true;
	stateWaitForTimeout[4]		= False;
	stateTransitionOnTimeout[4]	= "Armed";
	
	// Play fire animation for 0.5 seconds, then go back to Ready state
	stateName[5]				= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.35;
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= true;
	stateScript[5]				= "onFire";
	stateSequence[5]			= "Fire";
	stateEmitter[5]					= DrainArcaneCastEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";
	stateSound[5]				= DrainArcaneFireSound;
};

function DrainArcaneImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}


function DrainArcaneImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%projectile = %this.projectile;
	%spread = 0.0032;
	%shellcount = 15;
	%obj.playThread(2, plant);
                  %obj.client.bottomPrint("<color:FFFFFF>Current Hp: <color:FF0000>(<var:player:health>)",3);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function DrainArcaneImage::onMount(%this, %obj, %slot)
{	

			%obj.hideNode("LHand");
			%obj.hideNode("RHand");
			%obj.hideNode("LHook");
			%obj.hideNode("RHook");
   %obj.playThread(0,armReadyBoth);
}

function DrainArcaneImage::onUnMount(%this, %obj, %slot)
{	

			%obj.unhideNode("LHand");
			%obj.unhideNode("RHand");
		%obj.playThread(0, root);
}

function DrainArcaneItem::onAdd(%this, %obj)
{
	%obj.rotate = true;
	Parent::onAdd(%this, %obj);
}

function DrainArcaneProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;
   
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getType() & $TypeMasks::PlayerObjectType && %col.getType() & $TypeMasks::PlayerObjectType)
   {
      %firer = %obj.sourceObject;
      %col.damage(%obj, %pos, %directDamage, %damageType);
      
      if(%firer.getWhiteOut() < 0.2)
         %firer.setWhiteOut(0.2);
      
      if(getSimTime() - %firer.lastHealImageTime > 001)
      {
         %firer.mountImage(healImage,3);
         %firer.lastHealImageTime = getSimTime();
      }
      
      if(%firer.getDamageLevel() > 0)
      {
         if(%firer.getDamageFlash() < 0.3)
            %firer.setDamageFlash(0.3);
         
         %firer.addHealth(2);
      }
      else
      {
         %firer.setHealth(%firer.dataBlock.maxDamage);
      }
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}