datablock AudioProfile(PierceArcaneExplosionSound)
{
   filename    = "./PierceArcane_Hit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(PierceArcaneFireSound)
{
   filename    = "./PierceArcane_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PierceArcaneTravelSound)
{
   filename    = "./PierceArcane_Travel.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(PierceArcaneCastParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 30;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.45 0.8 0.9";
	colors[1]     = "0.75 0.45 0.8";
	sizes[0]      = 0.95;
	sizes[1]      = 1.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PierceArcaneCastEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PierceArcaneCastParticle";
};

datablock ParticleData(PierceArcaneChargedParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 100;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.5 0.8 0.4";
	colors[1]     = "0.8 0.5 0.8 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PierceArcaneChargedEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PierceArcaneChargedParticle";
};

datablock ParticleData(PierceArcaneProjectileParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 240.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.75 0.1 1 0.4";
	colors[1]     = "0.75 0.1 1 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleEmitterData(PierceArcaneProjectileEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PierceArcaneProjectileParticle";
};

datablock ParticleData(PierceArcaneExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.75 0.45 0.8 0.9";
	colors[1]     = "0.75 0.45 0.8 0.0";
	sizes[0]      = 0.95;
	sizes[0]      = 0.95;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PierceArcaneExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PierceArcaneExplosionParticle";

   useEmitterColors = true;
};

datablock ExplosionData(PierceArcaneExplosion)
{
   //explosionShape = "";
	soundProfile = PierceArcaneExplosionSound;

   lifeTimeMS = 120;

   emitter[0] = PierceArcaneExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0.15;
   lightEndRadius = 0.0;
   lightStartColor = "0.8 0.65 0.2";
   lightEndColor = "0 0 0";
};

//projectile
AddDamageType("PierceArcane",   '<bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',       '%2 <bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',1,1);
datablock ProjectileData(PierceArcaneProjectile)
{
   directDamage        = 25;
   directDamageType    = $DamageType::PierceArcane;
   radiusDamageType    = $DamageType::PierceArcane;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = PierceArcaneExplosion;
   particleEmitter     = PierceArcaneProjectileEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 165;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   sound = PierceArcaneTravelSound;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "PierceArcane";
};


//////////
// item //
//////////
datablock ItemData(PierceArcaneItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
                  shapeFile = "./ArcanePierceSymbol.dts";
                  rotate = true;
	emap = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	//gui stuff
	uiName = "Arcane + Drain";
	iconName = "./PierceArcane_Icon";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = PierceArcaneImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PierceArcaneImage)
{
   // Basic Item properties
   shapeFile = "./ArcanePierce.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.5 -0.6 -0.5";
   eyeOffset = "-0.385 1.05 -1.95";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PierceArcaneItem;
   ammo = " ";
   projectile = PierceArcaneProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arms up or not
   armReady = true;
   LarmReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateSequence[0]                = "Activate";
	stateTimeoutValue[0]            = 1.2;
	stateTransitionOnTimeout[0]     = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTimeoutValue[1]		   = 0.01;
	stateTransitionOnTimeout[1]	   = "Ready";
	stateWaitForTimeout[1]		   = true;
	stateAllowImageChange[1]	   = true;
	stateEmitter[1]			   = DrainArcaneChargedEmitter;
	stateEmitterTime[1]				= 0.1;
	stateEmitterNode[1]				= "muzzleNode";
	stateSound[1]				= DrainArcaneChargedSound;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]		= 0.35;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = PierceArcaneCastEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = PierceArcaneFireSound;

	stateName[3]			  = "Reload";
	stateTimeoutValue[3]		  = 1.0;
	stateTransitionOnTimeout[3]	  = "Wait";
	stateWaitForTimeout[3]		  = true;
	
	stateName[4]			  = "Wait";
	stateTimeoutValue[4]		  = 0.05;
	stateTransitionOnTimeout[4]	  = "Ready";
};

function PierceArcaneImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(2, plant);
                  %obj.client.bottomPrint("<color:FFFFFF>Current Hp: <color:FF0000>(<var:player:health>)",3);
	Parent::onFire(%this, %obj, %slot);
}

function PierceArcaneImage::onMount(%this, %obj, %slot)
{	

			%obj.hideNode("LHand");
			%obj.hideNode("RHand");
			%obj.hideNode("LHook");
			%obj.hideNode("RHook");
   %obj.playThread(0,armReadyBoth);
}

function PierceArcaneImage::onUnMount(%this, %obj, %slot)
{	

			%obj.unhideNode("LHand");
			%obj.unhideNode("RHand");
		%obj.playThread(0, root);
}

function PierceArcaneItem::onAdd(%this, %obj)
{
	%obj.rotate = true;
	Parent::onAdd(%this, %obj);
}

function PierceArcaneProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, -100, 100) * %scale;
   
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getType() & $TypeMasks::PlayerObjectType && %col.getType() & $TypeMasks::PlayerObjectType)
   {
      %firer = %obj.sourceObject;
      %col.damage(%obj, %pos, %directDamage, %damageType);
      
      if(%firer.getWhiteOut() < 0.2)
         %firer.setWhiteOut(0.2);
      
      if(getSimTime() - %firer.lastHealImageTime > 001)
      {
         %firer.mountImage(healImage,3);
         %firer.lastHealImageTime = getSimTime();
      }
      
      if(%firer.getDamageLevel() > 0)
      {
         if(%firer.getDamageFlash() < 0.3)
            %firer.setDamageFlash(0.3);
         
         %firer.addHealth(25);
      }
      else
      {
         %firer.setHealth(%firer.dataBlock.maxDamage);
      }
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}