datablock AudioProfile(PowerArcaneFullExplosionSound)
{
   filename    = "./PowerArcaneFullHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(PowerArcaneFullFireSound)
{
   filename    = "./PowerArcaneFullFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PowerArcaneFullChargingSound)
{
   filename    = "./PowerArcaneFullCharging.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PowerArcaneFullChargedSound)
{
   filename    = "./PowerArcaneFullCharged.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(PowerArcaneFullCastParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 30;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.25 0.25 0.9";
	colors[1]     = "0.8 0.25 0.25 0.0";
	sizes[0]      = 0.95;
	sizes[1]      = 1.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PowerArcaneFullCastEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullCastParticle";

   uiName = "Power Arcane Full Cast";
};

datablock ParticleData(PowerArcaneFullChargedParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.1 0.1 0.4";
	colors[1]     = "0.8 0.1 0.1 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PowerArcaneFullChargedEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullChargedParticle";

   uiName = "Power Arcane Full Charged";
};

datablock ParticleData(PowerArcaneFullChargingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.0 0.0 0.4";
	colors[1]     = "0.6 0.0 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PowerArcaneFullChargingEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = -5.0;
   velocityVariance = 2.0;
   ejectionOffset   = 0.75;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullChargingParticle";

   uiName = "Power Arcane Full Charging";
};


datablock ParticleData(PowerArcaneFullProjectileParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 240.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 0.1 0.1 0.4";
	colors[1]     = "1.0 0.1 0.1 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.75;

	useInvAlpha = false;
};

datablock ParticleEmitterData(PowerArcaneFullProjectileEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullProjectileParticle";

   uiName = "Power Arcane Full Trail";
};

datablock ParticleData(PowerArcaneFullExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.25 0.25 0.4";
	colors[1]     = "0.8 0.25 0.25 0.0";
	sizes[0]      = 1.75;
	sizes[1]      = 1.9;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PowerArcaneFullExplosionEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullExplosionParticle";

   useEmitterColors = true;
   uiName = "Power Arcane Full Hit";
};

datablock ParticleData(PowerArcaneFullExplosionBitsParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 750;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.2 0.2 0.9";
	colors[1]     = "0.8 0.2 0.2 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.45;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PowerArcaneFullExplosionBitsEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 26;
   velocityVariance = 4;
   ejectionOffset   = 0.45;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PowerArcaneFullExplosionBitsParticle";

   useEmitterColors = true;
   uiName = "Power Arcane Full Bits";
};

datablock ExplosionData(PowerArcaneFullExplosion)
{
   //explosionShape = "";
	soundProfile = PowerArcaneFullExplosionSound;

   lifeTimeMS = 430;

   particleEmitter = PowerArcaneFullExplosionBitsEmitter;
   particleDensity = 35;
   particleRadius = 1.15;

   emitter[0] = PowerArcaneFullExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0.15;
   lightEndRadius = 0.0;
   lightStartColor = "0.8 0.65 0.2";
   lightEndColor = "0 0 0";

   impulseRadius = 6;
   impulseForce = 2000;

   damageRadius = 6;
   radiusDamage = 120;
};

//projectile
AddDamageType("PowerArcaneFullDirect",   '<bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',    '%2 <bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',1,1);
datablock ProjectileData(PowerArcaneFullProjectile)
{
   directDamage        = 0;
   directDamageType    = $DamageType::PowerArcaneFullDirect;
   radiusDamageType    = $DamageType::PowerArcaneFullDirect;
   impactImpulse	   = 1500;
   verticalImpulse	   = 1500;
   explosion           = PowerArcaneFullExplosion;
   particleEmitter     = PowerArcaneFullProjectileEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 170;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "PowerArcaneFull";
};


//////////
// item //
//////////
datablock ItemData(PowerArcaneFullItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ArcanePowerFullSymbol.dts";
                  rotate = true;
	emap = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	//gui stuff
	uiName = "Arcane + Power";
	iconName = "./PowerArcaneFull_Icon";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = PowerArcaneFullImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PowerArcaneFullImage)
{
   // Basic Item properties
   shapeFile = "./ArcanePower.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.5 -0.6 -0.5";
   eyeOffset = "-0.41 1.05 -1.95";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PowerArcaneFullItem;
   ammo = " ";
   projectile = PowerArcaneFullProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	// Plays activate animation for 1.5 seconds when you first pull it out
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.5;
	stateSequence[0]	= "Activate";
	stateTransitionOnTimeout[0]       = "Ready";
	//stateSound[0]				= weaponSwitchSound;
	
	// We're idle and ready to start charging
	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1] = "Charge";
	stateSequence[1]	= "Ready";
	stateAllowImageChange[1]	= true;
	
	// Play charge animation for 2 seconds. Return to ready if released early
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 2;
                  stateSequence[2]	= "Charging";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateEmitter[2]					= PowerArcaneFullChargingEmitter;
	stateEmitterTime[2]				= 1.45;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]				= PowerArcaneFullChargingSound;
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = true;

                  // We wanted to abort the charge state
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.05;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= true;
	
	// We're charged up, go to Fire state when we release mouse
	stateName[4]			= "Armed";
	stateTimeoutValue[4]		= 0.3;
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateEmitter[4]					= PowerArcaneFullChargedEmitter;
	stateEmitterTime[4]				= 0.4;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]				= PowerArcaneFullChargedSound;
	stateAllowImageChange[4]	= true;
	stateWaitForTimeout[4]		= False;
	stateTransitionOnTimeout[4]	= "Armed";
	
	// Play fire animation for 0.5 seconds, then go back to Ready state
	stateName[5]				= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= true;
	stateScript[5]				= "onFire";
	stateSequence[5]			= "Fire";
	stateEmitter[5]					= PowerArcaneFullCastEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";
	stateSound[5]				= PowerArcaneFullFireSound;
};

function PowerArcaneFullImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function PowerArcaneFullImage::onFire(%this, %obj, %slot)
{
                  %obj.client.player.Addhealth(-15);
                  %obj.client.bottomPrint("<color:FFFFFF>You feel your life draining away: <color:FF0000>(<var:player:health>)",3);
	%obj.playthread(2, plant);
	Parent::onFire(%this, %obj, %slot);
}

function PowerArcaneFullImage::onMount(%this, %obj, %slot)
{	

			%obj.hideNode("LHand");
			%obj.hideNode("RHand");
			%obj.hideNode("LHook");
			%obj.hideNode("RHook");
   %obj.playThread(0,armReadyBoth);
}

function PowerArcaneFullImage::onUnMount(%this, %obj, %slot)
{	

			%obj.unhideNode("LHand");
			%obj.unhideNode("RHand");
		%obj.playThread(0, root);
}

function PowerArcaneFullItem::onAdd(%this, %obj)
{
	%obj.rotate = true;
	Parent::onAdd(%this, %obj);
}