//audio
datablock AudioProfile(RapidArcaneFireSound)
{
   filename    = "./RapidArcaneFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RapidArcaneHitSound)
{
   filename    = "./RapidArcaneImpact.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(RapidArcaneCastParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 30;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.75 0.3 0.9";
	colors[1]     = "0.65 0.55 0.15 0.0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.7;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RapidArcaneCastEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RapidArcaneCastParticle";

   uiName = "Rapid Arcane Cast";
};

datablock ParticleData(RapidArcaneCastBitsParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 150;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.65 0.2 0.4";
	colors[1]     = "0.8 0.65 0.2 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RapidArcaneCastBitsEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RapidArcaneCastBitsParticle";

   uiName = "Rapid Arcane Cast Bit";
};

datablock ParticleData(RapidArcaneProjectileParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 240.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.8 0.55 0.2 0.4";
	colors[1]     = "0.8 0.65 0.2 0.0";
	sizes[0]      = 0.40;
	sizes[1]      = 0.30;

	useInvAlpha = false;
};

datablock ParticleEmitterData(RapidArcaneProjectileEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RapidArcaneProjectileParticle";

   uiName = "Rapid Arcane Trail";
};

datablock ParticleData(RapidArcaneExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.75 0.3 0.9";
	colors[1]     = "0.65 0.55 0.15 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 1.65;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RapidArcaneExplosionEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RapidArcaneExplosionParticle";

   useEmitterColors = true;
   uiName = "Rapid Arcane Hit";
};

datablock ParticleData(RapidArcaneExplosionBitsParticle)
{
	dragCoefficient      = 0.5;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.8 0.70 0.3 0.9";
	colors[1]     = "0.65 0.50 0.10 0.0";
	sizes[0]      = 0.28;
	sizes[1]      = 0.18;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RapidArcaneExplosionBitsEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0.0;
   thetaMin         = 35;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RapidArcaneExplosionBitsParticle";

   useEmitterColors = true;
   uiName = "Rapid Arcane Bits";
};

datablock ExplosionData(RapidArcaneExplosion)
{
   //explosionShape = "";
	soundProfile = RapidArcaneHitSound;

   lifeTimeMS = 120;

   particleEmitter = RapidArcaneExplosionBitsEmitter;
   particleDensity = 7;
   particleRadius = 1.15;

   emitter[0] = RapidArcaneExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0.15;
   lightEndRadius = 0.0;
   lightStartColor = "0.8 0.65 0.2";
   lightEndColor = "0 0 0";
};

AddDamageType("rapidarcane",   '<bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',    '%2 <bitmap:add-ons/Weapon_Package_ArcaneMagics/CI_Arcane> %1',0.2,1);
datablock ProjectileData(rapidarcaneProjectile)
{
   directDamage        = 12.5;
   directDamageType    = $DamageType::rapidarcane;
   radiusDamageType    = $DamageType::rapidarcane;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = RapidArcaneExplosion;
   particleEmitter     = RapidArcaneProjectileEmitter;

   muzzleVelocity      = 160;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightStartRadius = 0.15;
   lightEndRadius = 0.0;
   lightStartColor = "0.8 0.65 0.2";
   lightEndColor = "0 0 0";

   uiName = "Arcane Rapid Projectile";
};

//////////
// item //
//////////
datablock ItemData(rapidarcaneItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ArcaneRapidSymbol.dts";
	rotate = true;
	emap = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	//gui stuff
	uiName = "Arcane - Rapid";
	iconName = "./RapidArcane_Icon";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = rapidarcaneImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(rapidarcaneImage)
{
   // Basic Item properties
   shapeFile = "./ArcaneRapid.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.5 -0.6 -0.5";
   eyeOffset = "-0.4 1.05 -2.05";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = rapidarcaneItem;
   ammo = " ";
   projectile = rapidarcaneProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReadyBoth = true;


   doColorShift = true;
   colorShiftColor = rapidarcaneItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateSequence[0]	= "Activate";
	stateTransitionOnTimeout[0]       = "Ready";

	stateSound[0]					= activateSound;

	stateName[1]                     = "Ready";
	stateSequence[1]	= "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;


	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
	stateTimeoutValue[2]            = 0.125;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= RapidArcaneCastEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEjectShell[2]       	  = true;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= RapidArcaneFireSound;
   stateSequence[2]                = "Fire";
	stateEjectShell[2]       = false;





	stateName[3] = "Smoke";
	stateEmitter[3]					= RapidArcaneCastBitsEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.0;
        stateTransitionOnTimeout[3]     = "Reload";



	stateName[4]			= "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.0005;
	stateWaitForTimeout[4]		= true;
	stateTransitionOnTimeout[4]     = "Check";
	//stateTransitionOnTriggerUp[4]     = "Ready";

	
	stateName[5]			= "Check";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Ready";
	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.0005;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		    = true;

	stateScript[6]                  = "onStopFire";
};

function rapidarcaneImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%projectile = %this.projectile;
	%spread = 0.0014;
	%shellcount = 1;
	%obj.playThread(2, plant);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function rapidarcaneImage::onMount(%this, %obj, %slot)
{	

			%obj.hideNode("LHand");
			%obj.hideNode("RHand");
			%obj.hideNode("LHook");
			%obj.hideNode("RHook");
		%obj.playThread(0, armreadyboth);
}

function rapidarcaneImage::onUnMount(%this, %obj, %slot)
{	

			%obj.unhideNode("LHand");
			%obj.unhideNode("RHand");
		%obj.playThread(0, root);
}

function rapidarcaneItem::onAdd(%this, %obj)
{
	%obj.rotate = true;
	Parent::onAdd(%this, %obj);
}